//Generated by the protocol buffer compiler. DO NOT EDIT!
// source: dsepractice/chinese/v1alpha1/core_types.proto

package gg.dsepractice.chinese.v1alpha1;

@kotlin.jvm.JvmName("-initializeleaderboardEntry")
inline fun leaderboardEntry(block: gg.dsepractice.chinese.v1alpha1.LeaderboardEntryKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.LeaderboardEntry =
  gg.dsepractice.chinese.v1alpha1.LeaderboardEntryKt.Dsl._create(gg.dsepractice.chinese.v1alpha1.LeaderboardEntry.newBuilder()).apply { block() }._build()
object LeaderboardEntryKt {
  @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
  @com.google.protobuf.kotlin.ProtoDslMarker
  class Dsl private constructor(
    private val _builder: gg.dsepractice.chinese.v1alpha1.LeaderboardEntry.Builder
  ) {
    companion object {
      @kotlin.jvm.JvmSynthetic
      @kotlin.PublishedApi
      internal fun _create(builder: gg.dsepractice.chinese.v1alpha1.LeaderboardEntry.Builder): Dsl = Dsl(builder)
    }

    @kotlin.jvm.JvmSynthetic
    @kotlin.PublishedApi
    internal fun _build(): gg.dsepractice.chinese.v1alpha1.LeaderboardEntry = _builder.build()

    /**
     * <code>bool is_current_user = 1 [json_name = "isCurrentUser"];</code>
     */
    var isCurrentUser: kotlin.Boolean
      @JvmName("getIsCurrentUser")
      get() = _builder.getIsCurrentUser()
      @JvmName("setIsCurrentUser")
      set(value) {
        _builder.setIsCurrentUser(value)
      }
    /**
     * <code>bool is_current_user = 1 [json_name = "isCurrentUser"];</code>
     */
    fun clearIsCurrentUser() {
      _builder.clearIsCurrentUser()
    }

    /**
     * <code>int64 score = 2 [json_name = "score"];</code>
     */
    var score: kotlin.Long
      @JvmName("getScore")
      get() = _builder.getScore()
      @JvmName("setScore")
      set(value) {
        _builder.setScore(value)
      }
    /**
     * <code>int64 score = 2 [json_name = "score"];</code>
     */
    fun clearScore() {
      _builder.clearScore()
    }

    /**
     * <code>.google.protobuf.Duration time_taken = 3 [json_name = "timeTaken"];</code>
     */
    var timeTaken: com.google.protobuf.Duration
      @JvmName("getTimeTaken")
      get() = _builder.getTimeTaken()
      @JvmName("setTimeTaken")
      set(value) {
        _builder.setTimeTaken(value)
      }
    /**
     * <code>.google.protobuf.Duration time_taken = 3 [json_name = "timeTaken"];</code>
     */
    fun clearTimeTaken() {
      _builder.clearTimeTaken()
    }
    /**
     * <code>.google.protobuf.Duration time_taken = 3 [json_name = "timeTaken"];</code>
     * @return Whether the timeTaken field is set.
     */
    fun hasTimeTaken(): kotlin.Boolean {
      return _builder.hasTimeTaken()
    }
  }
}
inline fun gg.dsepractice.chinese.v1alpha1.LeaderboardEntry.copy(block: gg.dsepractice.chinese.v1alpha1.LeaderboardEntryKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.LeaderboardEntry =
  gg.dsepractice.chinese.v1alpha1.LeaderboardEntryKt.Dsl._create(this.toBuilder()).apply { block() }._build()

val gg.dsepractice.chinese.v1alpha1.LeaderboardEntryOrBuilder.timeTakenOrNull: com.google.protobuf.Duration?
  get() = if (hasTimeTaken()) getTimeTaken() else null

